/* Kishimot's Train ver 0.03 */
#include <libtrain.h>
#include <ncurses.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXSTATION 15
#define MAXSTATIONNAME 120
#define MAXCOLUMN 21

#define YSIZE 24
#define XSIZE 76

char *
getLine(char *buf){
	int i;

	i=0;
	buf[strlen(buf)-1]='\0';
	while(1){
		if(buf[i]=='\0') break;
		if (((unsigned char)buf[i] & 0x80) != 0) i++;
		i++;
		if(i>XSIZE) {
			buf[i]='\0';
			break;
		}
	}
	return buf;
}


void
winInit(){
	initscr();
	cbreak(); 
	noecho(); nonl();
	clear();
}

void
winEnd(){
	nocbreak(); 
	echo(); nl();
	endwin();
}

void
scrInit(){
	clear();
	move(0,0);
	printw("ֱ:");
	move(1,0);printw("ֱ:");
	move(0,8);
	refresh();
}

void
clrlist(){
	move(3,0);
	clrtobot();
}

void
getlist(char *name,int *list){
	char number[MAXCOLUMN];
	int cookie = 0;
	int listcount = 0;
	int len = 0;

	clrlist();
	while ((list[listcount] = Train_GetStationComplementCandidate(
					name, strlen(name), &cookie)) >= 0){
		move(3+listcount,1);
		if(listcount<10){
			printw("%d >%s", listcount, Train_GetStationName(list[listcount]));
		}else{
			printw("X >%s",  Train_GetStationName(list[listcount]));
		}
		listcount++;
		list[listcount]=99;
		if(listcount > MAXSTATION){
			move(4+listcount,1);
			printw("---> Too many Station\n");
			break;
		}
	}
}

int getstation(int posy)
{
	char c;
	char name[MAXSTATIONNAME];
	char name2[MAXSTATIONNAME];
	int list[MAXSTATION];
	int len=0;

	name[0]='\0';
	list[0]=99;

	clrlist();
	refresh();
	while(1){
		c=getch();
		if(c =='q'){
				winEnd();
				exit(0);
		}else if(((c >='a')&&(c<='z'))||(c==' ')||(c=='-')||(c=='\'')){
			name[len]=c;
			len++;
			name[len]='\0';
			strcpy(name2,name);
			move(posy,8);
			addstr(name2);
			getlist(name2,list);
			move(posy,8+len);
			refresh();
		}else if(c==''){
			list[0]=99;
			len=0;
			name[0]='\0';
			move(posy,8);
			clrtoeol();
			move(posy,8);
			clrlist();
			refresh();
		}else if(c=='\b'){
			if(len>0){
				name[--len]='\0';
				move(posy,len+8);
				addch(' ');
				getlist(name,list);
				if(len==0){
					clrlist();
				}
				move(posy,len+8);
				refresh();
			}
		}else if((c >='0')&&(c<='9')){
			if(list[0]!=99) {
				move(posy,8);
				clrtoeol();
				addstr(Train_GetStationName(list[c-'0']));
				move(posy,8);
				refresh();
				return list[c-'0'];
			}
		}
	}
}

int main(int argc,char *argv[])
{
	extern char *optarg;
	extern int optind;
	char c;
	int startid, endid;

	Train_Initialize();
	winInit();

	while ((c = getopt(argc,argv,"d:")) != EOF){
		switch(c){
			case 'd':
				Train_SetDataFile(optarg);
				break;
		}
	}

	while(1){
		scrInit();

		startid = Train_SetStartPoint(Train_GetStationNameInRoman(getstation(0)));
		endid = Train_SetStartPoint(Train_GetStationNameInRoman(getstation(1)));
		Train_Search(startid, endid);
    
	 	clrlist();
		move(3,0);
		printw("⤭=%s, Ԥ=%s, ֻ=%s, =%s\n",
			Train_GetWalkText(),
			Train_GetWaitText(),
			Train_GetJoushaText(),
			Train_GetTotalText());
		printw("%s", Train_GetResultText());
		refresh();

		while(c = getch()){
			if(c=='q'){
				winEnd();
				exit(0);
			}else if(c=='\r'){
				break;
			}
		}
	}
	return 0;
}


